@ECHO OFF

IF (%3) == () GOTO USAGE
IF NOT (%4) == () GOTO USAGE

SET INPUT_FILE=%~f1
SET MAN_RSA_KEY=%~f2
SET ORIG_RSA_KEY=%~f3

IF NOT EXIST "%INPUT_FILE%"   GOTO ERROR_INPUT_FILE
IF NOT EXIST "%MAN_RSA_KEY%"  GOTO ERROR_MAN_RSA_KEY
IF NOT EXIST "%ORIG_RSA_KEY%" GOTO ERROR_ORIG_RSA_KEY

:: Change drive and directory
%~d0
CD %~p0

SET BASE_NAME=.\%~n1

hex470 -q -m -memwidth 32 -romwidth 32 "%INPUT_FILE%" -o %BASE_NAME%_32.m0
IF ERRORLEVEL 1 GOTO ERROR_HEX470

gencert -gencertrsa "%INPUT_FILE%" %BASE_NAME%_32.m0 ".cert" %BASE_NAME%_cert.out "%MAN_RSA_KEY%" "%ORIG_RSA_KEY%" 0 %BASE_NAME%_gencert_debug.txt %BASE_NAME%.pc 0 0 > %BASE_NAME%_gencert_output.txt
IF ERRORLEVEL 1 GOTO ERROR_GENCERT

hex470 -q -m -memwidth 16 -romwidth 16 %BASE_NAME%_cert.out -o %BASE_NAME%_cert.m0
IF ERRORLEVEL 1 GOTO ERROR_HEX470

DEL /Q %BASE_NAME%.pc %BASE_NAME%_32.m0 %BASE_NAME%_cert.out %BASE_NAME%_gencert_* gencert.dbg

GOTO END

:USAGE
ECHO Usage: %~n0 ^<COFF file^> ^<Manufacturer RSA key^> ^<Originator RSA key^>
ECHO.
ECHO Options:
ECHO    ^<COFF file^>            = COFF formatted (.out) file
ECHO    ^<Manufacturer RSA key^> = Manufacturer RSA key generated by GenCert
ECHO    ^<Originator RSA key^>   = Originator RSA key generated by GenCert
GOTO END

:ERROR_INPUT_FILE
ECHO Error: The input file, %INPUT_FILE%, does not exist.
GOTO END

:ERROR_MAN_RSA_KEY
ECHO Error: The manufacturer RSA key, %MAN_RSA_KEY%, does not exist.
GOTO END

:ERROR_ORIG_RSA_KEY
ECHO Error: The originator RSA key, %ORIG_RSA_KEY%, does not exist.
GOTO END

:ERROR_HEX470
ECHO Error: Hex470 failed.
GOTO END

:ERROR_GENCERT
ECHO Error: GenCert failed.
GOTO END

:END
SET INPUT_FILE=
SET MAN_RSA_KEY=
SET ORIG_RSA_KEY=
SET BASE_NAME=
