#
# FLUID pc Makefile using MSVC compiler
#
# $Id: pc_msc.mak 1.5 Thu, 01 Aug 2002 11:17:20 +0200 mmj $
#



# Environment variable set by vcvars32.bat
# Used by M$ compiler only
MSVCDIRINC  := $(MSVCDir)/Include
MSVCLIBDIR  := $(MSVCDir)/Lib

DEFINES  := /DOS=WIN32 /DTARGET=0 /DMSC=1

PCDIR = pc

# Auto-generated objects
AUTOOBJS := $(PCDIR)/efluid.obj
AUTOSRCS := $(PCDIR)/efluid.c

INCLUDES :=  /I$(PCDIR) $(patsubst %, /I%, $(subst ;, ,$(MSVCDIRINC)))


# /Od and /Zi are for debug
CFLAGS   += $(DEFINES) /W2 /Yd /nologo /Od /MD /Zi 

LDFLAGS  := /LIBPATH:$(MSVCLIBDIR) /nologo /subsystem:console /incremental:no /machine:I386 /DEBUG

CC       := cl

#Only for statically linked libraries - KERNEL32.DLL is used
#LIBS     := $(MSVCLIBDIR)/KERNEL32.LIB

# You don't have to change these variables
SRCS     := $(wildcard $(PCDIR)/*.c)
SRCS     := $(filter-out $(AUTOSRCS), $(SRCS))
BNAMES   := $(basename $(SRCS))
OBJS     := $(addsuffix .obj, $(BNAMES)) $(AUTOOBJS)
DEPS     += $(addsuffix .d, $(BNAMES))
CFLAGS   += $(INCLUDES)

$(OBJS) : %.obj : %.c
	$(CC) $(CFLAGS) /c $< /Fo$@

fluid.exe: $(OBJS)
	link /OUT:$@ $^ $(LDFLAGS) $(LIBS)

$(AUTOSRCS): $(PCDIR)\$(PCDIR).mak $(PCDIR)\fluid.h $(PCDIR)\mke.pl
	perl -w $(PCDIR)\mke.pl < $(PCDIR)\fluid.h > $@

-include $(DEPS)
