#
#
# FLUID pc Makefile using Borland compiler
#
# $Id: pc_bcc.mak 1.3 Thu, 27 Jun 2002 14:30:29 +0200 mmj $
#

PCDIR = pc

DEFINES := -DTARGET=0 -DOS=WIN32 -DBCC=1

#SRCS related to M$VC and BCC
MSVC_SRCS := $(PCDIR)/getopt.c

#Borland variables
BCC_INCLUDE := "D:\BC5\INCLUDE"  "D:\BC5\INCLUDE\WIN32"
BCC_LIBS_DIR:= "D:\BC5\LIB"
BCC_OBJS_DIR:= "D:\BC5\LIB"
CC          := bcc32
LINKER      := tlink32
CFLAGS      := -n$(PCDIR) -w $(DEFINES)
INCLUDE     := -I$(PCDIR) $(patsubst %, -I%, $(BCC_INCLUDE))
LDFLAGS     := -x -L$(BCC_LIBS_DIR) -j$(BCC_OBJS_DIR) -Tpe -ap -n
LIBS        := cw32.lib import32.lib


# Auto-generated objects/srcs
AUTOOBJS := $(PCDIR)/efluid.obj
AUTOSRCS := $(PCDIR)/efluid.c

SRCS   := $(wildcard $(PCDIR)/*.c)
SRCS   := $(filter-out $(AUTOSRCS), $(SRCS))

BNAMES := $(basename $(SRCS))
OBJS   := $(addsuffix .obj, $(BNAMES)) $(AUTOOBJS)
DEPS   += $(addsuffix .d, $(BNAMES))
CFLAGS += $(INCLUDE)

$(OBJS) : %.obj : %.c
	$(CC) $(CFLAGS) -c $< -o $@

#NOTE: BCC linker doesn't like "/" slashes *AT ALL* - Thus using "subst" thing
#NOTE: BCC linker separates arguments with commas and the linker sequence rule
#      objfiles, exefile, mapfile, libfiles, deffile, resfiles *must* be followed
fluid.exe: $(OBJS)
	$(LINKER) $(LDFLAGS) $(subst /,\$,$(OBJS)) c0x32.obj , $@, , $(LIBS)

$(PCDIR)/efluid.c: $(PCDIR)/$(PCDIR).mak $(PCDIR)/fluid.h $(PCDIR)/mke.pl
	perl -w $(PCDIR)/mke.pl < $(PCDIR)/fluid.h > $@

-include $(DEPS)
