/******************************************************************************
 * Fluid (Flash Loader Utility Independent of Device)
 *
 * Mads Meisner-Jensen, mmj@ti.com.
 *
 * Target Debug /Tracing functionality
 *
 * $Id: debug.c 1.5 Tue, 22 Jan 2002 11:28:00 +0100 mmj $
 *
 ******************************************************************************/


/******************************************************************************
 * Debug Functions
 ******************************************************************************/

void debug_putstr(bss_t *bss, char *string)
{
    char ch;

    putchar(bss, PROTO_TRACE);
    putchar(bss, 'S');
    while ((ch = *string++))
        putchar(bss, ch);
    putchar(bss, ch);
}

void debug_putnum(bss_t *bss, unsigned int number)
{
    putchar(bss, PROTO_TRACE);
    putchar(bss, 'N');
    putchar(bss, number);
    putchar(bss, number >>  8);
    putchar(bss, number >> 16);
    putchar(bss, number >> 24);
}


/******************************************************************************
 * LED control
 *****************************************************************************/

#if (DEBUG_LED == 1)

// Just set the bits, no checking whatsoever
void led_set(bss_t *bss, uint16 n)
{
    *bss->leds.baddr =
    *bss->leds.daddr = bss->leds.state = n;
}

void led_clr(bss_t *bss, uint16 n)
{
    *bss->leds.baddr =
    *bss->leds.daddr = bss->leds.state &= ~n;
}

void led_on(bss_t *bss, uint16 n)
{
    *bss->leds.baddr =
    *bss->leds.daddr = bss->leds.state = bss->leds.state | (1 << n);
}

void led_off(bss_t *bss, uint16 n)
{
    *bss->leds.baddr =
    *bss->leds.daddr = bss->leds.state = bss->leds.state & ~(1 << n);
}

void led_toggle(bss_t *bss, uint16 n)
{
    *bss->leds.baddr =
    *bss->leds.daddr = bss->leds.state = bss->leds.state ^ (1 << n);
}

#endif // (DEBUG_LED == 1)



